<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>KPluginSelector</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>KPluginSelector Class Reference</h1>
<code>from PyKDE4.kutils import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />


<h2>Detailed Description</h2>

<p>A widget to select what plugins to load and configure the plugins.
</p>
<p>
It shows the list of available plugins
</p>
<p>
Since the user needs a way to know what a specific plugin does every plugin
sould install a desktop file containing a name, comment and category field.
The category is useful for applications that can use different kinds of
plugins like a playlist, skin or visualization
</p>
<p>
The location of these desktop files is the
share/apps/&amp;lt;instancename&amp;gt;/&amp;lt;plugindir&amp;gt; directory. But if you need
you may use a different directory
</p>
<p>
You can add plugins from different KConfig[group], by just calling all times
you want addPlugins method with the correct parameters
</p>
<p>
Additionally, calls to constructor with same <b>categoryName,</b> will add new
items to the same category, even if plugins are from different categories
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Matthias Kretz &lt;kretz@kde.org&gt; </dd></dl>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Rafael Fernández López &lt;ereslibre@kde.org&gt; </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj202976332">PluginLoadMethod</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;ReadConfigFile, IgnoreConfigFile&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Signals</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200358860">changed</a> (bool hasChanged)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200358572">configCommitted</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qbytearray.html">QByteArray</a> componentName)</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197061164">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197059628">addPlugins</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> componentName, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> categoryName=QString(), <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> categoryKey=QString(), KSharedConfig.Ptr config=KSharedConfig.Ptr())</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj181389132">addPlugins</a> (self, <a href="../kdecore/KComponentData.html">KComponentData</a> instance, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> categoryName=QString(), <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> categoryKey=QString(), KSharedConfig.Ptr config=KSharedConfig.Ptr())</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162583116">addPlugins</a> (self, [<a href="../kdecore/KPluginInfo.html">KPluginInfo</a>] pluginInfoList, KPluginSelector.PluginLoadMethod pluginLoadMethod=KPluginSelector.ReadConfigFile, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> categoryName=QString(), <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> categoryKey=QString(), KSharedConfig.Ptr config=KSharedConfig.Ptr())</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200358860">changed</a> (self, bool hasChanged)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200358572">configCommitted</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qbytearray.html">QByteArray</a> componentName)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200357356">defaults</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162584812">load</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162583948">save</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj200358124">updatePluginsState</a> (self)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj197061164"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Create a new KPluginSelector
</p></div></div><a class="anchor" name="obj197059628"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> addPlugins</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>componentName</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>categoryName=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>categoryKey=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">KSharedConfig.Ptr&nbsp;</td>
<td class="paramname"><em>config=KSharedConfig.Ptr()</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Add a list of KParts plugins
</p>
<p>
The information about the plugins will be loaded from the
share/apps/&amp;lt;instancename&amp;gt;/kpartplugins directory
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>componentName</em>&nbsp;</td><td> The name of the KComponentData of the plugin's parent.

<tr><td></td><td valign="top"><em>categoryName</em>&nbsp;</td><td> The translated name of the category. This is the
name that is shown in the title. If the category
did exist before because of another call to
addPlugins, then they will be shown in that
category. If <b>categoryName</b> is a new one, then
a new category will be shown on the plugin window,
and the list of plugins added to it

<tr><td></td><td valign="top"><em>categoryKey</em>&nbsp;</td><td> When you have different categories of KParts
plugins you distinguish between the plugins using
the Category key in the .desktop file. Use this
parameter to select only those KParts plugins
with the Category key == <b>categoryKey.</b> If
<b>categoryKey</b> is not set the Category key is
ignored and all plugins are shown. Not match case

<tr><td></td><td valign="top"><em>config</em>&nbsp;</td><td> The KConfig object that holds the state of the
plugins being enabled or not. By default it should
be componentData.config(). It is recommended to
always pass a KConfig object if you use
KSettings.PluginPage since you never know from where the
page will be called (think global config app).
For example KViewCanvas passes KConfig(
"kviewcanvas" )
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj181389132"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> addPlugins</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KComponentData.html">KComponentData</a>&nbsp;</td>
<td class="paramname"><em>instance</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>categoryName=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>categoryKey=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">KSharedConfig.Ptr&nbsp;</td>
<td class="paramname"><em>config=KSharedConfig.Ptr()</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Add a list of KParts plugins. Convenience method for the one above.
If not set explicitly, <b>config</b> is set to componentData.config()
</p></div></div><a class="anchor" name="obj162583116"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> addPlugins</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">[<a href="../kdecore/KPluginInfo.html">KPluginInfo</a>]&nbsp;</td>
<td class="paramname"><em>pluginInfoList</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">KPluginSelector.PluginLoadMethod&nbsp;</td>
<td class="paramname"><em>pluginLoadMethod=KPluginSelector.ReadConfigFile</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>categoryName=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>categoryKey=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">KSharedConfig.Ptr&nbsp;</td>
<td class="paramname"><em>config=KSharedConfig.Ptr()</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Add a list of non-KParts plugins
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>pluginInfoList</em>&nbsp;</td><td> A list of KPluginInfo objects containing the
necessary information for the plugins you want to
add to the list

<tr><td></td><td valign="top"><em>pluginLoadMethod</em>&nbsp;</td><td> If KPluginSelector will try to load the
state of the plugin when loading the
dialog from the configuration file or not.
This is useful if for some reason you
called the setPluginEnabled() for each plugin
individually before loading the dialog, and
don't want KPluginSelector to override them
when loading

<tr><td></td><td valign="top"><em>categoryName</em>&nbsp;</td><td> The translated name of the category. This is the
name that is shown in the title. If the category
did exist before because of another call to
addPlugins, then they will be shown in that
category. If <b>categoryName</b> is a new one, then
a new category will be shown on the plugin window,
and the list of plugins added to it

<tr><td></td><td valign="top"><em>categoryKey</em>&nbsp;</td><td> When you have different categories of KParts
plugins you distinguish between the plugins using
the Category key in the .desktop file. Use this
parameter to select only those KParts plugins
with the Category key == <b>categoryKey.</b> If
<b>categoryKey</b> is not set the Category key is
ignored and all plugins are shown. Not match case

<tr><td></td><td valign="top"><em>config</em>&nbsp;</td><td> The KConfig object that holds the state of the
plugins being enabled or not. By default it will
use KGlobal.config(). It is recommended to
always pass a KConfig object if you use
KSettings.PluginPage since you never know from
where the page will be called (think global
config app). For example KViewCanvas passes
KConfig("kviewcanvas")
</td></tr>
</table></dl>
<p> <dl class="note" compact><dt><b>Note:</b></dt><dd> All plugins that were set a config group using setConfig() method
will load and save their information from there. For those that
weren't any config object, <b>config</b> will be used
</dd></dl>
</p></div></div><a class="anchor" name="obj200358860"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> changed</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>hasChanged</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Tells you whether the configuration is changed or not.
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("changed(bool)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj200358572"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> configCommitted</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qbytearray.html">QByteArray</a>&nbsp;</td>
<td class="paramname"><em>componentName</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted after the config of an embedded KCM has been saved. The
argument is the name of the parent component that needs to reload
its config
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("configCommitted(const QByteArray&)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj200357356"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> defaults</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Change to applications defaults
</p></div></div><a class="anchor" name="obj162584812"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> load</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Load the state of the plugins (selected or not) from the KPluginInfo
objects
</p></div></div><a class="anchor" name="obj162583948"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> save</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Save the configuration
</p></div></div><a class="anchor" name="obj200358124"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> updatePluginsState</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Updates plugins state (enabled or not)
</p>
<p>
This method won't save anything on any configuration file. It will just
be useful if you added plugins with the method:
</p>
<p>
<pre class="fragment">
 void addPlugins(const QList&lt;KPluginInfo&gt; &amp;pluginInfoList,
                 const QString &amp;categoryName = QString(),
                 const QString &amp;categoryKey = QString(),
                 const KSharedConfig.Ptr &amp;config = KSharedConfig.Ptr());
</pre>
</p>
<p>
To sum up, this method will update your plugins state depending if plugins
are ticked or not on the KPluginSelector dialog, without saving anything
anywhere
</p></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj202976332"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">PluginLoadMethod</td>
</tr>
</table>
</div>
<div class="memdoc"><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>ReadConfigFile</em>&nbsp;=&nbsp;0</td><td><tr><td valign="top"><em>IgnoreConfigFile</em>&nbsp;</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
